!  Compile_Rch.f90 
!
!  FUNCTIONS:
!  Compile_Rch - Entry point of console application.
!

!****************************************************************************
!
!  PROGRAM: Compile_Rch
!
!  PURPOSE:  Entry point for the console application.
!
!****************************************************************************
MODULE PARAM

    DATA MasterDIR /'W:\COHYST\COHYST\Run028\Run028b2\Inputs\'/
    DATA MasterFile /'MasterInput_v27.1.txt'/

    CHARACTER*12, ALLOCATABLE ::    Crops(:)
    
    CHARACTER*1000  INDIR, OUTDIR, WBPDIR, LUDIR, CNLDIR, MasterDIR
    CHARACTER*1000  MISCDIR, MIDIR
    CHARACTER*250   GWLUfld, SWLUfld, COLUfld, DryLUfld, GWCfld
    CHARACTER*250   GWLU, SWLU, COLU, DryLU, cRun, MODname
    CHARACTER*250   CellLoc, Coeffile, AEfile, ROZfile, GWCfile, MasterFile
    CHARACTER*250   PctRchfile, SWidxfile, CountID, Cell_county
    CHARACTER*250   cnlmastfile, miscrmastfile, miscpmastfile, mirmastfile, mipmastfile
    CHARACTER*250   ActCellFile
    !Added 1/7/2016
    CHARACTER*250   Callyrfile
    
    INTEGER     ncells, nczones, nrzones, nsoils, nirrdist, ncrops
    INTEGER     startyr, endyr, DPonly, SWonly
    INTEGER     ncols, nrows, cnlrflg, miscrflg, miscpflg, mirflg, mipflg
    INTEGER     Rch0flg
    !Added 1/7/2016
    INTEGER     ctrlyrs
    
    REAL    csize

    CHARACTER*1   Line(150)
    CHARACTER*4     YRT
    
    INTEGER     iyear, i, vln

END MODULE PARAM
!****************************************************************************
PROGRAM Compile_Rch
    USE PARAM
    IMPLICIT NONE
    
    OPEN (1, FILE = TRIM(MasterDIR)//TRIM(MasterFile), STATUS = 'OLD')
    READ (1, *)

    READ (1, *) cRun
    READ (1, *) MODname
    READ (1, *) INDIR
    READ (1, *) OUTDIR
    READ (1, *) WBPDIR
    READ (1, *) LUDIR
    READ (1, *) CNLDIR
    READ (1, *) MiscDIR
    READ (1, *) MIDIR
    READ (1, *) GWLUfld
    READ (1, *) SWLUfld
    READ (1, *) COLUfld
    READ (1, *) DryLUfld
    READ (1, *) GWLU
    READ (1, *) SWLU
    READ (1, *) COLU
    READ (1, *) DryLU
    READ (1, *) GWCfld
    READ (1, *) GWCfile
    READ (1, *) CellLoc
    READ (1, *) Coeffile
    READ (1, *) AEfile
    READ (1, *) ROZfile
    READ (1, *) PctRchfile
    READ (1, *) SWidxfile
    READ (1, *) CountID
    READ (1, *) Cell_county
    READ (1, *) CNLmastfile
    READ (1, *) MISCrmastfile
    READ (1, *) MISCpmastfile
    READ (1, *) MIrmastfile
    READ (1, *) MIpmastfile
    READ (1, *) ActCellfile
    !Added 1/7/2016
    READ (1, *) CallYrfile
    READ (1, *) ncells
    READ (1, *) startyr
    READ (1, *) endyr
    READ (1, *) RCH0flg
    READ (1, *) DPonly
    READ (1, *) SWonly
    READ (1, *) cnlrflg
    READ (1, *) miscrflg
    READ (1, *) miscpflg
    READ (1, *) MIrflg
    READ (1, *) MIpflg
    !Added 1/7/2016
    READ (1, *) ctrlyrs
    READ (1, *) nczones
    READ (1, *) nrzones
    READ (1, *) nsoils
    READ (1, *) nirrdist
    READ (1, *) csize
    READ (1, *) ncols
    READ (1, *) nrows
    READ (1, *) ncrops
    
    ALLOCATE (Crops(ncrops))
    
    DO i = 1, ncrops
        READ (1, *) crops(i)
    END DO
    CLOSE (1)
    
    OUTDIR = TRIM(OUTDIR)//TRIM(cRun)//'\Results\'
    
    OPEN (10, FILE = TRIM(OUTDIR)//TRIM(MODname)//'_'//TRIM(cRun)//'.RCH', STATUS = 'UNKNOWN')
    WRITE (10, 100)
    WRITE (10, 101)
    WRITE (10, 102)
    
    DO iyear = startyr, endyr
        WRITE (6, *) iyear
        WRITE (YRT, '(I4)') iyear
        
        OPEN (1, FILE = TRIM(OUTDIR)//'RCH\'//TRIM(MODname)//TRIM(YRT)//'.RCH', STATUS = 'OLD')
        DO WHILE (.NOT. EOF(1))
            READ (1, '(150A1)') Line(:)
            DO i = 150, 1, -1
                IF (Line(i) .NE. " ") THEN
                    vln = i
                    GOTO 1
                END IF
            END DO
            
1           WRITE (10, 105) (Line(i), i = 1, vln)
        END DO 
        CLOSE (1)
    END DO
    
100 FORMAT('#MODFLOW2000 Recharge Package')
101 FORMAT('PARAMETER  0')
102 FORMAT('         3        40')
105 FORMAT(<vln>A1)
END PROGRAM Compile_Rch
!****************************************************************************