!  Complie_WEL.f90 
!
!  FUNCTIONS:
!  Complie_WEL - Entry point of console application.
!

!****************************************************************************
!
!   PROGRAM:
!   Do 
!  
!
!****************************************************************************
MODULE PARAM

    DATA MasterDIR /'W:\COHYST\COHYST\Run028\Run028b2\Inputs\'/
    DATA MasterFile /'MasterInput_v27.1.txt'/

    CHARACTER*12, ALLOCATABLE ::    Crops(:)
    
    CHARACTER*1000  INDIR, OUTDIR, WBPDIR, LUDIR, CNLDIR, MasterDIR
    CHARACTER*1000  MISCDIR, MIDIR
    CHARACTER*250   GWLUfld, SWLUfld, COLUfld, DryLUfld, GWCfld
    CHARACTER*250   GWLU, SWLU, COLU, DryLU, cRun, MODname
    CHARACTER*250   CellLoc, Coeffile, AEfile, ROZfile, GWCfile, MasterFile
    CHARACTER*250   PctRchfile, SWidxfile, CountID, Cell_county
    CHARACTER*250   cnlmastfile, miscrmastfile, miscpmastfile, mirmastfile, mipmastfile
    CHARACTER*250   ActCellFile
    !Added 1/7/2016
    CHARACTER*250   Callyrfile
    
    INTEGER     ncells, nczones, nrzones, nsoils, nirrdist, ncrops
    INTEGER     startyr, endyr, DPonly, SWonly
    INTEGER     ncols, nrows, cnlrflg, miscrflg, miscpflg, mirflg, mipflg
    INTEGER     Rch0flg
    !Added 1/7/2016
    INTEGER     ctrlyrs
    
    REAL    csize
    
    CHARACTER*4     YRT
    CHARACTER*1     LINE(50)
    
    INTEGER     i, iyear, MLPSP
    INTEGER     vln
    
    INTEGER, ALLOCATABLE :: MLSP(:)
    
END MODULE PARAM
!****************************************************************************
PROGRAM Complie_WEL
    USE PARAM
    IMPLICIT NONE
    
    OPEN (1, FILE = TRIM(MasterDIR)//TRIM(MasterFile), STATUS = 'OLD')
    READ (1, *)

    READ (1, *) cRun
    READ (1, *) MODname
    READ (1, *) INDIR
    READ (1, *) OUTDIR
    READ (1, *) WBPDIR
    READ (1, *) LUDIR
    READ (1, *) CNLDIR
    READ (1, *) MiscDIR
    READ (1, *) MIDIR
    READ (1, *) GWLUfld
    READ (1, *) SWLUfld
    READ (1, *) COLUfld
    READ (1, *) DryLUfld
    READ (1, *) GWLU
    READ (1, *) SWLU
    READ (1, *) COLU
    READ (1, *) DryLU
    READ (1, *) GWCfld
    READ (1, *) GWCfile
    READ (1, *) CellLoc
    READ (1, *) Coeffile
    READ (1, *) AEfile
    READ (1, *) ROZfile
    READ (1, *) PctRchfile
    READ (1, *) SWidxfile
    READ (1, *) CountID
    READ (1, *) Cell_county
    READ (1, *) CNLmastfile
    READ (1, *) MISCrmastfile
    READ (1, *) MISCpmastfile
    READ (1, *) MIrmastfile
    READ (1, *) MIpmastfile
    READ (1, *) ActCellfile
    !Added 1/7/2016
    READ (1, *) CallYrfile
    READ (1, *) ncells
    READ (1, *) startyr
    READ (1, *) endyr
    READ (1, *) RCH0flg
    READ (1, *) DPonly
    READ (1, *) SWonly
    READ (1, *) cnlrflg
    READ (1, *) miscrflg
    READ (1, *) miscpflg
    READ (1, *) MIrflg
    READ (1, *) MIpflg
    !Added 1/7/2016
    READ (1, *) ctrlyrs
    READ (1, *) nczones
    READ (1, *) nrzones
    READ (1, *) nsoils
    READ (1, *) nirrdist
    READ (1, *) csize
    READ (1, *) ncols
    READ (1, *) nrows
    READ (1, *) ncrops
    
    ALLOCATE (Crops(ncrops))
    
    DO i = 1, ncrops
        READ (1, *) crops(i)
    END DO
    CLOSE (1)
    
    OUTDIR = TRIM(OUTDIR)//TRIM(cRun)//'\Results\'
    
    ALLOCATE (MLSP(startyr : endyr))
    
    DO iyear = startyr, endyr
        WRITE (YRT, '(I4)') iyear
        OPEN (iyear, FILE = TRIM(OUTDIR)//'WEL\'//TRIM(MODname)//TRIM(YRT)//'.WEL', STATUS = 'OLD')
        READ (iyear, *) MLSP(iyear)
    END DO
    
    MLPSP = MAXVAL(MLSP)
    
    OPEN (1, FILE = TRIM(OUTDIR)//TRIM(MODname)//'_'//TRIM(cRun)//'.WEL', STATUS = 'UNKNOWN')
    WRITE (1, 100)
    WRITE (1, 101)
    WRITE (1, 102) MLPSP, 40
    
    DO iyear = startyr, endyr
        WRITE(6, *) iyear
        DO WHILE (.NOT. EOF(iyear))
            READ (iyear, 103) Line(:)
            DO i = 50, 1, -1
                IF (Line(i) .NE. " ") THEN
                    vln = i
                    GOTO 1
                END IF
            END DO
            
1           WRITE (1, 104) (Line(i) , i = 1, vln)
        END DO
    END DO
    
    CLOSE (1)
    DO iyear = startyr, endyr
        CLOSE (iyear)
    END DO

100 FORMAT('# MODFLOW2000 Well Package')  
101 FORMAT('PARAMETER  0  0')  
102 FORMAT(2I10) 
103 FORMAT (50A1)
104 FORMAT (<vln>A1)
    
    
END PROGRAM Complie_WEL
!****************************************************************************