!  District_Demand.f90 
!
!  FUNCTIONS:
!  District_Demand - Entry point of console application.
!

!****************************************************************************
!
!  PROGRAM: District_Demand
!
!  PURPOSE:  Entry point for the console application.
!
!****************************************************************************
MODULE PARAM

    DATA MasterDIR /'W:\COHYST\COHYST\Run028\Run028b2\Inputs\'/
    DATA MasterFile /'MasterInput_v27.1.txt'/

    CHARACTER*12,  ALLOCATABLE ::    Crops(:)
    CHARACTER*100, ALLOCATABLE ::    SWdistname(:)
    
    CHARACTER*1000  INDIR, OUTDIR, WBPDIR, LUDIR, CNLDIR, MasterDIR
    CHARACTER*1000  MISCDIR, MIDIR
    CHARACTER*250   GWLUfld, SWLUfld, COLUfld, DryLUfld, GWCfld
    CHARACTER*250   GWLU, SWLU, COLU, DryLU, cRun, MODname
    CHARACTER*250   CellLoc, Coeffile, AEfile, ROZfile, GWCfile, MasterFile
    CHARACTER*250   PctRchfile, SWidxfile, CountID, Cell_county
    CHARACTER*250   cnlmastfile, miscrmastfile, miscpmastfile, mirmastfile, mipmastfile
    CHARACTER*250   ActCellFile
    !Added 1/7/2016
    CHARACTER*250   Callyrfile
    
    INTEGER     ncells, nczones, nrzones, nsoils, nirrdist, ncrops
    INTEGER     startyr, endyr, DPonly, SWonly
    INTEGER     ncols, nrows, cnlrflg, miscrflg, miscpflg, mirflg, mipflg
    INTEGER     Rch0flg
    !Added 1/7/2016
    INTEGER ctrlyrs
    
    REAL    csize

    CHARACTER*4     YRT
    
    INTEGER     i,  indx, swdist, iyear, cell, yr, SWDindx, pflag, idx, ival
    
    REAL    annval, monval(12)
    
    INTEGER, ALLOCATABLE :: sidx(:), ZeroRCH(:)
    
    REAL, ALLOCATABLE :: SWD(:, :)
    
    
END MODULE PARAM 
!****************************************************************************
PROGRAM District_Demand
    USE PARAM
    IMPLICIT NONE

    OPEN (1, FILE = TRIM(MasterDIR)//TRIM(MasterFile), STATUS = 'OLD')
    READ (1, *)

    READ (1, *) cRun
    READ (1, *) MODname
    READ (1, *) INDIR
    READ (1, *) OUTDIR
    READ (1, *) WBPDIR
    READ (1, *) LUDIR
    READ (1, *) CNLDIR
    READ (1, *) MiscDIR
    READ (1, *) MIDIR
    READ (1, *) GWLUfld
    READ (1, *) SWLUfld
    READ (1, *) COLUfld
    READ (1, *) DryLUfld
    READ (1, *) GWLU
    READ (1, *) SWLU
    READ (1, *) COLU
    READ (1, *) DryLU
    READ (1, *) GWCfld
    READ (1, *) GWCfile
    READ (1, *) CellLoc
    READ (1, *) Coeffile
    READ (1, *) AEfile
    READ (1, *) ROZfile
    READ (1, *) PctRchfile
    READ (1, *) SWidxfile
    READ (1, *) CountID
    READ (1, *) Cell_county
    READ (1, *) CNLmastfile
    READ (1, *) MISCrmastfile
    READ (1, *) MISCpmastfile
    READ (1, *) MIrmastfile
    READ (1, *) MIpmastfile
    READ (1, *) ActCellfile
    !Added 1/7/2016
    READ (1, *) CallYrfile
    READ (1, *) ncells
    READ (1, *) startyr
    READ (1, *) endyr
    READ (1, *) RCH0flg    
    READ (1, *) DPonly
    READ (1, *) SWonly
    READ (1, *) cnlrflg
    READ (1, *) miscrflg
    READ (1, *) miscpflg
    READ (1, *) MIrflg
    READ (1, *) MIpflg
    !Added 1/7/2016
    READ (1, *) ctrlyrs
    READ (1, *) nczones
    READ (1, *) nrzones
    READ (1, *) nsoils
    READ (1, *) nirrdist
    READ (1, *) csize
    READ (1, *) ncols
    READ (1, *) nrows
    READ (1, *) ncrops
    
    ALLOCATE (Crops(ncrops))
    
    DO i = 1, ncrops
        READ (1, *) crops(i)
    END DO
    CLOSE (1)
    
    ALLOCATE (SIDX(nirrdist), SWdistname(nirrdist))
    ALLOCATE (SWD(nirrdist, 12))
    ALLOCATE (ZeroRCH(ncells))
    
    OUTDIR = TRIM(OUTDIR)//TRIM(cRun)//'\Results\'
    
    sidx = 0
    SWdistname = ""
    !Read SWIndex
    OPEN (1, FILE = TRIM(INDIR)//TRIM(SWidxfile), STATUS = 'OLD')
    READ (1, *)
    DO WHILE (.NOT. EOF(1))
        READ (1, 99) indx, swdist, swdistname(indx)
99      FORMAT (I3, I3, A15)         
        sidx(indx) = swdist
    END DO
    CLOSE (1)  
    
    ZeroRCH = 0
    IF (RCH0flg .EQ. 1) THEN
        !Determine Nulled Cells 
        OPEN (1, FILE = TRIM(INDIR)//TRIM(ActCellfile), STATUS = 'OLD')
        READ (1, *)
        DO WHILE (.NOT. EOF(1))
            READ (1, *) cell, idx, ZeroRCH(cell)
        END DO
        CLOSE (1)
    END IF
    
    OPEN (10, FILE = TRIM(OUTDIR)//'DemIrr/HDRSW/Distdemand.txt', STATUS = 'UNKNOWN')
    WRITE (10, 100)
    
    DO iyear = startyr, endyr
        WRITE (YRT, '(I4)') iyear
        SWD = 0.
        
        OPEN (1, FILE = TRIM(OUTDIR)//'DemIrr/HDRSW/SWdist'//TRIM(YRT)//'.txt', STATUS = 'OLD')
        READ (1, *)
        
        DO WHILE (.NOT. EOF(1))
            READ (1, *) cell, yr, swdist, swdindx, pflag, Annval, monval
            IF (ZeroRCH(cell) .EQ. 0) SWD(swdindx, :) = SWD(swdindx, :) + monval
        END DO
        CLOSE (1)
        
        DO indx = 1, nirrdist
            annval = SUM(SWD(indx, :))
            ival = len(TRIM(SWdistname(indx)))
            
            WRITE (10, 101) yr, indx, sidx(indx), annval, SWD(indx, :), SUM(SWD(indx, 6:9)), SWdistname(indx)
        END DO
        
    END DO
    CLOSE (1)
    
100 FORMAT ('Year, SW_indx, SW_District, Ann_Dem, Jan_Dem, Feb_Dem, Mar_Dem, Apr_Dem, May_Dem, Jun_Dem, Jul_Dem, Aug_Dem, Sep_Dem, Oct_Dem, Nov_Dem, Dec_Dem, Irr Season Demand, SW_Dist_Name')
101 FORMAT (I5, 2(',', I3), 14(',', F12.2), ',', A<ival>)
    
END PROGRAM District_Demand
!****************************************************************************