!  Make_Wel.f90 
!
!  FUNCTIONS:
!  Make_Wel - Entry point of console application.
!

!****************************************************************************
!
!  PROGRAM: Make_Wel
!
!  PURPOSE:  Entry point for the console application.
!
!****************************************************************************
MODULE PARAM

    DATA MasterDIR /'W:\COHYST\COHYST\Run028\Run028b2\Inputs\'/
    DATA MasterFile /'MasterInput_v27.1.txt'/
    
    CHARACTER*12, ALLOCATABLE ::    Crops(:)
    
    CHARACTER*1000  INDIR, OUTDIR, WBPDIR, LUDIR, CNLDIR, MasterDIR
    CHARACTER*1000  MISCDIR, MIDIR
    CHARACTER*250   GWLUfld, SWLUfld, COLUfld, DryLUfld, GWCfld
    CHARACTER*250   GWLU, SWLU, COLU, DryLU, cRun, MODname
    CHARACTER*250   CellLoc, Coeffile, AEfile, ROZfile, GWCfile, MasterFile
    CHARACTER*250   PctRchfile, SWidxfile, CountID, Cell_county
    CHARACTER*250   cnlmastfile, miscrmastfile, miscpmastfile, mirmastfile, mipmastfile
    CHARACTER*250   ActCellFile
    !Added 1/7/2016
    CHARACTER*250   Callyrfile
    
    INTEGER     ncells, nczones, nrzones, nsoils, nirrdist, ncrops
    INTEGER     startyr, endyr, DPonly, SWonly
    INTEGER     ncols, nrows, cnlrflg, miscrflg, miscpflg, mirflg, mipflg
    INTEGER     Rch0flg, idx
    !Added 1/7/2016
    INTEGER     ctrlyrs
    
    REAL    csize
    
    CHARACTER*250   pmpfld, pmpfile
    CHARACTER*4     YRT
    !Added 1/7/2016
    CHARACTER*4     YRTmisc, YRTmi
    
    INTEGER     LPSP(12), DayIM(12), MSPSP
    INTEGER     i, n, iyear, startmon, endmon, cell, yr
    INTEGER     pflag, swdist, col, row, layer
    
    REAL    cellacs, cellpmp(0 : 12), pvol(0 : 12), Totp
    
    INTEGER, ALLOCATABLE :: ZeroRCH(:)
    !Added 1/7/2016
    INTEGER, ALLOCATABLE :: yrctrl(:)
    INTEGER, ALLOCATABLE :: MISCyear(:), MIyear(:)    
    
    REAL, ALLOCATABLE :: IrrCellp(:,:), Municellp(:, :), MiscCellp(:, :)

    DATA DayIM /31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/
    DATA Layer /1/
    
END MODULE PARAM
!****************************************************************************
PROGRAM Make_Wel
    USE PARAM
    IMPLICIT NONE
    
    OPEN (1, FILE = TRIM(MasterDIR)//TRIM(Masterfile), STATUS = 'OLD')
    READ (1, *)
    
    READ (1, *) cRun
    READ (1, *) MODname
    READ (1, *) INDIR
    READ (1, *) OUTDIR
    READ (1, *) WBPDIR
    READ (1, *) LUDIR
    READ (1, *) CNLDIR
    READ (1, *) MiscDIR
    READ (1, *) MIDIR
    READ (1, *) GWLUfld
    READ (1, *) SWLUfld
    READ (1, *) COLUfld
    READ (1, *) DryLUfld
    READ (1, *) GWLU
    READ (1, *) SWLU
    READ (1, *) COLU
    READ (1, *) DryLU
    READ (1, *) GWCfld
    READ (1, *) GWCfile
    READ (1, *) CellLoc
    READ (1, *) Coeffile
    READ (1, *) AEfile
    READ (1, *) ROZfile
    READ (1, *) PctRchfile
    READ (1, *) SWidxfile
    READ (1, *) CountID
    READ (1, *) Cell_county
    READ (1, *) CNLmastfile
    READ (1, *) MISCrmastfile
    READ (1, *) MISCpmastfile
    READ (1, *) MIrmastfile
    READ (1, *) MIpmastfile
    READ (1, *) ActCellfile
    !Added 1/7/2016
    READ (1, *) CallYrfile
    READ (1, *) ncells
    READ (1, *) startyr
    READ (1, *) endyr
    READ (1, *) RCH0flg
    READ (1, *) DPonly
    READ (1, *) SWonly
    READ (1, *) cnlrflg
    READ (1, *) miscrflg
    READ (1, *) miscpflg
    READ (1, *) MIrflg
    READ (1, *) MIpflg
    !Added 1/7/2016
    READ (1, *) ctrlyrs
    READ (1, *) nczones
    READ (1, *) nrzones
    READ (1, *) nsoils
    READ (1, *) nirrdist
    READ (1, *) csize
    READ (1, *) ncols
    READ (1, *) nrows
    READ (1, *) ncrops
    
    ALLOCATE (Crops(ncrops))
    
    DO i = 1, ncrops
        READ (1, *) crops(i)
    END DO
    CLOSE (1)
    
    OUTDIR = TRIM(OUTDIR)//TRIM(cRun)//'\Results\'
    
    ALLOCATE (IrrCellp(ncells, 0 : 12), Municellp(ncells, 0 : 12), MiscCellp(ncells, 0 : 12))
    ALLOCATE (ZeroRCH(ncells))
    
    !Added 1/7/2016
    ALLOCATE (yrctrl(ctrlyrs))
    ALLOCATE (MISCyear(startyr : endyr), MIyear(startyr : endyr))
    
    ZeroRCH = 0
    IF (RCH0flg .EQ. 1) THEN
        !Determine Nulled Cells
        OPEN (1, FILE = TRIM(INDIR)//TRIM(ActCellfile), STATUS = 'OLD')
        READ (1, *)
        DO WHILE (.NOT. EOF(1))
            READ (1, *) cell, idx, ZeroRCH(cell)
        END DO
        CLOSE (1)
    END IF
    
    !Read in Call year
    !Added 1/7/2016 to control the annual input data and allow the same data to be applied to different years
    !ex: applying a fixed land use to the historical climate
    OPEN (1, FILE = TRIM(INDIR)//TRIM(CallYrFile), STATUS = 'OLD')
    READ (1, *)
    DO WHILE (.NOT. EOF(1))
        READ (1, *) yr, yrctrl
        IF ((yr .GE. startyr) .AND. (yr .LE. endyr)) THEN
            Miscyear(yr) = yrctrl(5)
            MIyear(yr) = yrctrl(6)
        END IF
    END DO
    CLOSE (1)
    
    
    OPEN (10, FILE = TRIM(OUTDIR)//'Pmp_values.txt', STATUS = 'UNKNOWN')
    WRITE (10, 100)
    
    !Added 1/7/2016
    WRITE (6, 600)
    
    DO iyear = startyr, endyr
        !Altered 1/7/2016
        WRITE (6, 601) iyear, MISCyear(iyear), MIyear(iyear)
        WRITE (YRT, '(I4)') iyear
        
        !Added 1/7/2016
        WRITE (YRTmisc, '(I4)') MISCyear(iyear)
        WRITE (YRTmi, '(I4)') MIyear(iyear)
        
        IF (MOD(iyear, 4) .EQ. 0) THEN
            DayIM(2) = 29
        ELSE
            DayIM(2) = 28
        END IF
        
        IF (iyear .LT. 1985) THEN
            startmon = 10
            endmon = 12
        ELSE
            startmon = 1
            endmon = 12
        END IF
        
        IrrCellp = 0.
        !Read in Annual Irrigation Pumping from WSPP
        OPEN (1, FILE = TRIM(OUTDIR)//'pump\pump'//TRIM(YRT)//'.txt', STATUS = 'OLD')
        READ (1, *)
        DO WHILE (.NOT. EOF(1))
            READ (1, *) Cell, Yr, pflag, swdist, cellacs, cellPmp
            IrrCellp(cell, :) = IrrCellp(cell, :) + cellPmp(:)
            IF (ZeroRch(cell) .EQ. 1) IrrCellp(cell, :) = 0.
        END DO
        CLOSE (1)
        
        MuniCellp = 0.
        IF (MIpflg .EQ. 1) THEN
            OPEN (1, FILE = TRIM(INDIR)//TRIM(MIpmastfile), STATUS = 'OLD')
            READ (1, *)
            DO WHILE (.NOT. EOF(1))
                READ (1, *) pmpfld, pmpfile
            
                OPEN (2, FILE = TRIM(MIDIR)//TRIM(pmpfld)//'\'//TRIM(pmpfile)//TRIM(YRTmi)//'.txt', STATUS = 'OLD')
                READ (2, *)
                DO WHILE (.NOT. EOF(2))
                    READ (2, *) cell, yr, pvol
                    Municellp(cell, :) = Municellp(cell, :) + pvol
                    IF (ZeroRch(cell) .EQ. 1) Municellp(cell, :) = 0.
                END DO
                CLOSE (2)
                
            END DO
            CLOSE (1)
        END IF
        
        Misccellp = 0.
        IF (miscpflg .EQ. 1) THEN
            OPEN (1, FILE = TRIM(INDIR)//TRIM(MISCpmastfile), STATUS = 'OLD')
            READ (1, *)
            DO WHILE (.NOT. EOF(1))
                READ (1, *) pmpfld, pmpfile
                
                OPEN (2, FILE = TRIM(MiscDIR)//TRIM(pmpfld)//'\'//TRIM(pmpfile)//TRIM(YRTmisc)//'.txt', STATUS = 'OLD')
                READ (2, *)
                DO WHILE (.NOT. EOF(2))
                    READ (2, *) cell, yr, pvol
                    MiscCellp(cell, :) = MiscCellp(cell, :) + pvol
                    IF (ZeroRCH(cell) .EQ. 1) MiscCellp(cell, :) = 0.
                END DO
                CLOSE (2)
                
            END DO
            CLOSE (1)
        END IF
        
        LPSP = 0
        DO i = 1, ncells
            DO n = 1, 12
                IF (IrrCellp(i, n) + Misccellp(i, n) + MuniCellp(i, n) .GT. 0.) LPSP(n) = LPSP(n) + 1
            END DO
        END DO
        
        MSPSP = MAXVAL(LPSP)
        
        OPEN (20, FILE = TRIM(OUTDIR)//'WEL\'//TRIM(MODname)//TRIM(YRT)//'.WEL', STATUS = 'UNKNOWN')
        OPEN (30, FILE = TRIM(OUTDIR)//'Wellchk\Wellchk'//TRIM(YRT)//'.txt', STATUS = 'UNKNOWN')
        
        WRITE (20, 120) MSPSP
        WRITE (30, 130)
        
        DO n = startmon, endmon
            WRITE (20, 120) LPSP(n), 0
            DO i = 1, ncells
                
                col = MOD(i, ncols)
                IF (col .EQ. 0) col = ncols
                row = (i - col) / ncols + 1
                
                Totp = IrrCellp(i, n) + MiscCellp(i, n) + MuniCellp(i, n)
                
                IF (Totp .GT. 0.) THEN
                    WRITE (20, 121) Layer, row, col, 0.0 - (Totp * 43560 / DayIM(n))
                    WRITE (30, 131) cell, layer, row, col, iyear, n, DayIM(n), Totp / DayIM(n), Totp * 43560 / DayIM(n)
                END IF
                
                IF (n .EQ. 1) THEN
                    Totp = SUM(IrrCellp(i, 1 : 12)) + SUM(MiscCellp(i, 1 : 12)) + SUM(MuniCellp(i, 1 : 12))
                    WRITE (10, 101) i, iyear, MAX(Totp, 0.) / csize * 12
                END IF
            END DO
        END DO
        
        CLOSE (20)
        CLOSE (30)
        
    END DO
    CLOSE (10)
    
100 FORMAT ('Cell, Year, Pumping_(in)')
101 FORMAT (I7, ',', I5, ',', F7.2)    
120 FORMAT (2I10)
121 FORMAT (3I10, F12.2)
130 FORMAT ('Cell, Layer, Row, Column, Year, Month, Days_in_Month, Pumping_AF/day, Pumping_ft3/day')
131 FORMAT (I7, 6(',', I5), ',', F12.7, ',', F12.2)

!Added 1/7/2016
600 FORMAT (' Sim Year,Misc Year,  MI Year')
601 FORMAT (I9, 2(',', I9))
    
END PROGRAM Make_Wel
!****************************************************************************
