!   SW_del_HDR2TFG.f90 
!
!   FUNCTIONS:
!   To covert the HDR SW daily deliveries to the monthly diversion total and combining them with
!   the SW demands from the Republican river into the annual canal supply format.
!
!****************************************************************************
!
!
!****************************************************************************

PROGRAM SW_del_HDR2TFG

    IMPLICIT NONE
    
    INTEGER, PARAMETER :: startyr = 1984
    INTEGER, PARAMETER :: endyr = 2010
    INTEGER, PARAMETER :: nirrdist = 26
    INTEGER, PARAMETER :: ncnls = 14
    
    DATA INDIR /'W:\COHYST\COHYST\Run028\Run028b2\Inputs\'/
    
    CHARACTER*125   INDIR, a
    
    INTEGER     sidx(56), cnls(ncnls)
    INTEGER     Actdist(nirrdist), indx, swdist
    INTEGER     yr, mon, iday, idist, i, iyear
    INTEGER     swidx(nirrdist)
    
    REAL    cnldel(ncnls)
    REAL    Distdel(nirrdist, startyr : endyr, 12)
    REAL    Annval, monval(12)

    sidx = 0
    !Read SWIndex
    OPEN (1, FILE = TRIM(INDIR)//'SWindex2.txt', STATUS = 'OLD')
    READ (1, *)
    DO WHILE (.NOT. EOF(1))
        READ (1, *) indx, swdist
        sidx(swdist) = indx
        swidx(indx) = swdist
    END DO
    CLOSE (1)
    
    OPEN (1, FILE = 'W:\COHYST\COHYST\Run028\Run028b2\SWModel\Run28a3_CanalDel.csv', STATUS = 'OLD')
    READ (1, *) a, a, a, a, a, cnls
    READ (1, *)
    
    Actdist = 0
    DO idist = 1, ncnls
        Actdist(sidx(cnls(idist))) = 1
1   END DO    
 
    Distdel = 0.
    DO WHILE (.NOT. EOF(1))
        READ (1, *) a, yr, mon, iday, cnldel
        DO i = 1, ncnls
            Distdel(sidx(cnls(i)), yr, mon) = Distdel(sidx(cnls(i)), yr, mon) + cnldel(i)
        END DO
    END DO
    CLOSE (1)
    
    OPEN (1, FILE = 'W:\COHYST\COHYST\Run028\Run028b2\Results\DemIrr\HDRSW\Distdemand.txt', STATUS = 'OLD')
    READ (1, *)
    DO WHILE (.NOT. EOF(1))
        READ (1, *) yr, indx, swdist, Annval, Monval
        IF (Actdist(indx) .EQ. 0) THEN
            Distdel(indx, yr, :) = Distdel(indx, yr, :) + monval    
        END IF
    END DO
    CLOSE (1)
    
    OPEN (10, FILE = 'W:\COHYST\COHYST\Run028\Run028b2\Results\AppIrr\DistDel.txt', STATUS = 'UNKNOWN')
    WRITE (10, 100)
    
    DO iyear = startyr, endyr
        DO idist = 1, nirrdist
            Annval = SUM(Distdel(idist, iyear, :))
            WRITE (10, 101) iyear, idist, swidx(idist), Annval, Distdel(idist, iyear, :)
        END DO
    END DO
    
    CLOSE (10)
    
100 FORMAT ('Year, SW_indx, SW_District, Ann_Sup, Jan_Sup, Feb_Sup, Mar_Sup, Apr_Sup, May_Sup, Jun_Sup, Jul_Sup, Aug_Sup, Sep_Sup, Oct_Sup, Nov_Sup, Dec_Sup')
101 FORMAT (I5, 2(',', I3), 13(',', F12.2))
    
END PROGRAM SW_del_HDR2TFG

!****************************************************************************